
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');
const TenantAccess = require('./tenantAccess');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Artifact_type_catalogDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const artifact_type_catalog = await db.artifact_type_catalog.create(
            {
                id: data.id || undefined,
        
        type_name: data.type_name
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        active_flag: data.active_flag
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await artifact_type_catalog.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        

        return artifact_type_catalog;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const artifact_type_catalogData = data.map((item, index) => ({
                id: item.id || undefined,
                
                type_name: item.type_name
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                active_flag: item.active_flag
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const artifact_type_catalog = await db.artifact_type_catalog.bulkCreate(artifact_type_catalogData, { transaction });

        // For each item created, replace relation files
        

        return artifact_type_catalog;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const artifact_type_catalog = await TenantAccess.findByPkOrThrow(db.artifact_type_catalog, id, options);


        

        const updatePayload = {};
        
        if (data.type_name !== undefined) updatePayload.type_name = data.type_name;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.active_flag !== undefined) updatePayload.active_flag = data.active_flag;
        
        
        updatePayload.updatedById = currentUser.id;

        await artifact_type_catalog.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await artifact_type_catalog.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        

        return artifact_type_catalog;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const artifact_type_catalog = await TenantAccess.findAllByIds(db.artifact_type_catalog, ids, options);

        await db.sequelize.transaction(async (transaction) => {
            for (const record of artifact_type_catalog) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of artifact_type_catalog) {
                await record.destroy({transaction});
            }
        });


        return artifact_type_catalog;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const artifact_type_catalog = await TenantAccess.findByPkOrThrow(db.artifact_type_catalog, id, options);

        await artifact_type_catalog.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await artifact_type_catalog.destroy({
            transaction
        });

        return artifact_type_catalog;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const artifact_type_catalog = await TenantAccess.findOne(db.artifact_type_catalog, where, options);

        if (!artifact_type_catalog) {
            return artifact_type_catalog;
        }

        const output = artifact_type_catalog.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await artifact_type_catalog.getOrganization({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.type_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'artifact_type_catalog',
                        'type_name',
                        filter.type_name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'artifact_type_catalog',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.active_flag) {
                where = {
                    ...where,
                active_flag: filter.active_flag,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.artifact_type_catalog.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'artifact_type_catalog',
                        'type_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.artifact_type_catalog.findAll({
            attributes: [ 'id', 'type_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['type_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.type_name,
        }));
    }

    
};

